jQuery(function ($) {
    jQuery(document).ready(function ($) {
        let startDate
        let endDate
        let numberGuest = 1
        let adults = 1
        let children = 0
        let infants = 0
        let pets = 0
        let customUrl = ``
        let isActive = false
        const minNights = dataTransfer && dataTransfer.minNights ? parseInt(dataTransfer.minNights) : 1
        const personCapacity = dataTransfer && dataTransfer.personCapacity ? parseInt(dataTransfer.personCapacity) : null
        const maxChildren = dataTransfer && dataTransfer.maxChildren ? parseInt(dataTransfer.maxChildren) : null
        const maxInfants = dataTransfer && dataTransfer.maxInfants ? parseInt(dataTransfer.maxInfants) : null
        const maxPets = dataTransfer && dataTransfer.maxPets ? parseInt(dataTransfer.maxPets) : null
        $('.check-in-date').daterangepicker({
            minDate: moment(),
            maxDate: moment().add(3, 'years'),
            autoUpdateInput: false,
            isInvalidDate: function(date) {
                if(dataTransfer && dataTransfer.constructor === Object && Object.keys(dataTransfer).length !== 0) {
                    return Object.values(dataTransfer.invalidDate).reduce(function (bool, e) {
                        return bool || date.format('YYYY-MM-DD') === e
                    }, false)
                }
            },
        })
        $('.check-in-date').on('apply.daterangepicker', function(ev, picker) {
            startDate = picker.startDate.format('YYYY-MM-DD')
            endDate = picker.endDate.format('YYYY-MM-DD')
            const diffTime = Math.abs(new Date(endDate) - new Date(startDate))
            const diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24))
            if (diffDays < parseInt(minNights)) {
                const strMessage = `Please choose range date greater than or equal ${minNights} day(s)`
                $('.booking-form-request').find('.error-message').empty()
                $('.booking-form-request').append('<p class="error-message">' + strMessage + '</p>')
                return
            }
            numberGuest = $(this).closest('.booking-form-request').find('.guest-input').val() || 1
            adults = $(this).closest('.booking-form-request').find('.adults-input').val() || 1
            children = $(this).closest('.booking-form-request').find('.childs-input').val() || 0
            infants = $(this).closest('.booking-form-request').find('.infants-input').val() || 0
            pets = $(this).closest('.booking-form-request').find('.pets-input').val() || 0
            $(this).val(picker.startDate.format('MM/DD/YYYY') + ' - ' + picker.endDate.format('MM/DD/YYYY'))
            $(this).attr('data-startDate', startDate)
            $(this).attr('data-endDate', endDate)
            if (dataTransfer && dataTransfer.constructor === Object && Object.keys(dataTransfer).length !== 0 && data_script) {
                $.ajax({
                    url: data_script.ajaxUrl,
                    type: 'POST',
                    data: ({
                        action: 'dtravel_booking_widget_calculate_tax',
                        start_date: startDate,
                        end_date: endDate,
                        number_guest: numberGuest,
                        adults: adults,
                        children: children,
                        infants: infants,
                        pets: pets,
                        property_dtravel_id: dataTransfer.propertyDtravelId,
                        currency: dataTransfer.currency,
                    }),
                    success: function (data) {
                        $('.booking-form-request').find('.tax-fee').empty()
                        $('.booking-form-request').find('.tax-fee').append(data)
                        const pricePerNight = $('.booking-form-request').find('.price-per-night').attr('data-price-per-night')
                        if (pricePerNight)
                            $('.booking-calendar-widget').find('.pernight_label').html(`${pricePerNight} per night`)
                        $.ajax({
                            url: `https://api-v3.dtravel.com/account-service/v1/user/info?userId=${dataTransfer.userId}`,
                            type: 'GET',
                            success: function (res) {
                                if (res && res.success === true && res.data) {
                                    dataTransfer.isActive = true
                                    const userCustomUrl = res.data.userCustomUrl || []
                                    if (userCustomUrl.length > 0) {
                                        const customFilter = userCustomUrl.find(e => e.isPrimary)
                                        const customId = customFilter.customId
                                        const type = customFilter.type
                                        customUrl = type === 'custom' ? `https://${customId}.dtravel.com` : `https://${customId}`
                                    } else {
                                        customUrl = `https://dtravel.com/${dataTransfer.userId}`
                                    }
                                }
                                isActive = true
                                console.log(isActive)
                                $('.booking-form-request').find('.booking-button').removeAttr('disabled')
                            }
                        })
                    }
                })
            }
        })
        $('.check-in-date').on('cancel.daterangepicker', function(ev, picker) {
            $(this).val('')
        })

        $('.guest-final').click(function () {
            $('.guest-popup').show()
        })
        $(document).mouseup(function(e)
        {
            const container = $('.guest-popup')
            if (!container.is(e.target) && container.has(e.target).length === 0) {
                const guestFinal = $('.apply-guest').attr('data-guest') ? parseInt($('.apply-guest').attr('data-guest')) : 1
                const textGuest = guestFinal === 1 ? `${guestFinal} guest` : `${guestFinal} guests`
                $('input[name="adults-number"]').val($('.apply-guest').attr('data-adult') || '1')
                $('.adults-value.value').html($('.apply-guest').attr('data-adult') || '1')
                $('input[name="childs-number"]').val($('.apply-guest').attr('data-child') || '0')
                $('.childs-value.value').html($('.apply-guest').attr('data-child') || '0')
                $('input[name="infants-number"]').val($('.apply-guest').attr('data-infant') || '0')
                $('.infants-value.value').html($('.apply-guest').attr('data-infant') || '0')
                $('input[name="pets-number"]').val($('.apply-guest').attr('data-pet') || '0')
                $('.pets-value.value').html($('.apply-guest').attr('data-pet') || '0')
                $('input[name="guest-number"]').val($('.apply-guest').attr('data-guest') || 1)
                $('.guest-final').html(textGuest || '1 guest')
                container.hide()
            }
        })
        $('.apply-guest').click(function () {
            numberGuest = $(this).closest('.booking-form-request').find('.guest-input').val() || 1
            adults = $(this).closest('.booking-form-request').find('.adults-input').val() || 1
            children = $(this).closest('.booking-form-request').find('.childs-input').val() || 0
            infants = $(this).closest('.booking-form-request').find('.infants-input').val() || 0
            pets = $(this).closest('.booking-form-request').find('.pets-input').val() || 0
            $(this).attr('data-guest', numberGuest)
            $(this).attr('data-adult', adults)
            $(this).attr('data-child', children)
            $(this).attr('data-infant', infants)
            $(this).attr('data-pet', pets)
            const startDateApply = $(this).closest('.booking-form-request').find('.check-in-date').attr('data-startDate')
            const endDateApply = $(this).closest('.booking-form-request').find('.check-in-date').attr('data-endDate')
            if (startDateApply && endDateApply) {
                if (dataTransfer && dataTransfer.constructor === Object && Object.keys(dataTransfer).length !== 0 && data_script) {
                    $.ajax({
                        url: data_script.ajaxUrl,
                        type: 'POST',
                        data: ({
                            action: 'dtravel_booking_widget_calculate_tax',
                            start_date: startDate,
                            end_date: endDate,
                            number_guest: numberGuest,
                            adults: adults,
                            children: children,
                            infants: infants,
                            pets: pets,
                            property_dtravel_id: dataTransfer.propertyDtravelId,
                            currency: dataTransfer.currency,
                        }),
                        success: function (data) {
                            $('.booking-form-request').find('.tax-fee').empty()
                            $('.booking-form-request').find('.tax-fee').append(data)
                            $('.booking-form-request').find('.booking-button').removeAttr('disabled')
                            const pricePerNight = $('.booking-form-request').find('.price-per-night').attr('data-price-per-night')
                            if (pricePerNight)
                                $('.booking-calendar-widget').find('.pernight_label').html(`${pricePerNight} per night`)
                        }
                    })
                }
            }
            $('.guest-popup').hide()
        })
        $('.plus').click(function () {
            const currentPlusVal = parseInt($(this).parent().find('input').val())
            const element = $(this).attr('data-element')
            let maxCap
            switch (element) {
                case 'adults':
                    maxCap = personCapacity
                    break
                case 'children':
                    maxCap = maxChildren
                    break
                default :
                    maxCap = null
                    break
            }
            const adultNumber = parseInt($(this).closest('.booking-form-request').find('.adults-input').val())
            const childNumber = parseInt($(this).closest('.booking-form-request').find('.childs-input').val())
            const totalGuest = parseInt(adultNumber) + parseInt(childNumber)
            if (
                (maxCap && personCapacity && currentPlusVal < maxCap && totalGuest < personCapacity) ||
                (!maxCap && personCapacity && totalGuest < personCapacity) ||
                (!personCapacity && maxCap && currentPlusVal < maxCap) ||
                (!maxCap && !personCapacity)
            ) {
                const setPlusVal = currentPlusVal + 1
                $(this).parent().find('input').val(setPlusVal.toString())
                $(this).parent().find('.value').html(setPlusVal)
                const currentPlusValGuest = $(this).closest('.guest-number-wraper').find('input[name="guest-number"]').val()
                let text = parseInt(currentPlusValGuest) === 0 ? ' Guest' : ' Guests'
                $(this).closest('.guest-number-wraper').find('input[name="guest-number"]').val((parseInt(currentPlusValGuest) + 1).toString())
                $(this).closest('.guest-number-wraper').find('.guest-final').html((parseInt(currentPlusValGuest) + 1).toString() + text)
            }
        })
        $('.minus').click(function () {
            const currenMinustVal = parseInt($(this).parent().find('input').val())
            const adultNumber = parseInt($(this).closest('.booking-form-request').find('.adults-input').val())
            const childNumber = parseInt($(this).closest('.booking-form-request').find('.childs-input').val())
            const totalGuest = parseInt(adultNumber) + parseInt(childNumber)
            if(currenMinustVal > 0 && totalGuest > 1) {
                const setMinusVal = currenMinustVal - 1
                $(this).parent().find('input').val(setMinusVal.toString())
                $(this).parent().find('.value').html(setMinusVal)
                const currentMinusValGuest = $(this).closest('.guest-number-wraper').find('input[name="guest-number"]').val()
                let text = parseInt(currentMinusValGuest) === 1 ? ' Guest' : ' Guests'
                $(this).closest('.guest-number-wraper').find('input[name="guest-number"]').val((parseInt(currentMinusValGuest) - 1).toString())
                $(this).closest('.guest-number-wraper').find('.guest-final').html((parseInt(currentMinusValGuest) - 1).toString() + text)
            }
        })
        $('.ignore-plus').click(function () {
            const element = $(this).attr('data-element')
            let maxCapIgnore
            switch (element) {
                case 'infants':
                    maxCapIgnore = maxInfants
                    break
                case 'pets':
                    maxCapIgnore = maxPets
                    break
                default :
                    maxCapIgnore = null
                    break
            }
            const currentPlusVal = parseInt($(this).parent().find('input').val())
            if ((maxCapIgnore && currentPlusVal < maxCapIgnore) || (!maxCapIgnore)) {
                const setPlusVal = currentPlusVal + 1
                $(this).parent().find('input').val(setPlusVal.toString())
                $(this).parent().find('.value').html(setPlusVal)
            }
        })
        $('.ignore-minus').click(function () {
            const currenMinustVal = parseInt($(this).parent().find('input').val())
            if(currenMinustVal > 0) {
                const setMinusVal = currenMinustVal - 1
                $(this).parent().find('input').val(setMinusVal.toString())
                $(this).parent().find('.value').html(setMinusVal)
            }
        })
        $('.booking-button').click(function () {
            if (dataTransfer && dataTransfer.constructor === Object && Object.keys(dataTransfer).length !== 0 && isActive)
                window.location.href = `${customUrl}/booking/${dataTransfer.propertyDtravelId}?check_in=${startDate}&check_out=${endDate}&guests=${numberGuest}&adults=${adults}&children=${children}&infants=${infants}&pets=${pets}`
            else {
                $('.booking-form-request').find('.error-message').empty()
                $('.booking-form-request').append('<p class="error-message">This property not allow on Dtravel</p>')
            }
        })
    })
})