<?php
/**
 * Generated by the WordPress Meta Box Generator
 * https://jeremyhixon.com/tool/wordpress-meta-box-generator/
 *
 * Retrieving the values:
 * Choose Dtravel property ID = get_post_meta( get_the_ID(), 'dtravel_choose-dtravel-property-id', true )
 */
class Dtravel_Custom_Field {
    private $config = '';
    public function __construct() {
        add_action( 'add_meta_boxes', [ $this, 'add_meta_boxes' ] );
        add_action( 'admin_head', [ $this, 'admin_head' ] );
        add_action( 'save_post', [ $this, 'save_post' ] );
        $dtravel_user_id = get_option('dtravel_user_value_widget');
        $body = array(
            'hostAddress' => $dtravel_user_id,
            'pageSize' => 1000,
            'page' => 1,
            'minPrice' => 1,
            'maxPrice' => 9999,
        );
        $args = array(
            'timeout' => 30,
            'redirection' => 30,
            'httpversion' => '1.0',
            'user-agent' => 'WordPress/' . $GLOBALS['wp_version'] . '; ' . home_url(),
            'blocking' => true,
            'headers' => array('content-type' => 'application/json'),
            'cookies' => array(),
            'compress' => false,
            'decompress' => true,
            'sslverify' => true,
            'stream' => false,
            'filename' => null,
        );
        $args['body'] = json_encode($body);
        $url = 'https://api-v3.dtravel.com/listing-service/v2/calendar/search';
        $response = wp_remote_post($url, $args);
        $data = json_decode(wp_remote_retrieve_body($response));
        $options = array();
        if ($data && $data->success === true && is_array($data->data) && count($data->data) > 0) {
            $options = array_map(function ($e) {
                return $e->id;
            }, $data->data);
        }
        $optionString = '';
        for ($i = 0; $i < count($options); $i++) {
            if ($i == 0)
                $optionString .= $options[$i].' : '.$options[$i];
            else
                $optionString .= '\r\n'.$options[$i].' : '.$options[$i];
        }
        $this->config = '{"title":"Dtravel Booking","description":"Input Dtravel\'s property id","prefix":"dtravel_","domain":"dtravel-booking-widget","class_name":"Dtravel_Custom_Field","post-type":["post"],"context":"normal","priority":"default","fields":[{"type":"select","label":"ID:","options":"'.$optionString.'","id":"dtravel_property_id"}]}';
        $this->config = json_decode( $this->config, true );
    }

    public function add_meta_boxes() {
        foreach ( $this->config['post-type'] as $screen ) {
            add_meta_box(
                sanitize_title( $this->config['title'] ),
                $this->config['title'],
                [ $this, 'add_meta_box_callback' ],
                $screen,
                $this->config['context'],
                $this->config['priority']
            );
        }
    }

    public function admin_head() {
        global $typenow;
        if ( in_array( $typenow, $this->config['post-type'] ) ) {
            ?><?php
        }
    }

    public function save_post( $post_id ) {
        foreach ( $this->config['fields'] as $field ) {
            switch ( $field['type'] ) {
                default:
                    if ( isset( $_POST[ $field['id'] ] ) ) {
                        $sanitized = sanitize_text_field( $_POST[ $field['id'] ] );
                        update_post_meta( $post_id, $field['id'], $sanitized );
                    }
            }
        }
    }

    public function add_meta_box_callback() {
        echo '<div class="rwp-description">' . $this->config['description'] . '</div>';
        $this->fields_table();
    }

    private function fields_table() {
        ?><table class="form-table" role="presentation">
        <tbody><?php
        foreach ( $this->config['fields'] as $field ) {
            ?><tr>
            <th scope="row"><?php $this->label( $field ); ?></th>
            <td><?php $this->field( $field ); ?></td>
            </tr><?php
        }
        ?></tbody>
        </table><?php
    }

    private function label( $field ) {
        switch ( $field['type'] ) {
            default:
                printf(
                    '<label class="" for="%s">%s</label>',
                    $field['id'], $field['label']
                );
        }
    }

    private function field( $field ) {
        switch ( $field['type'] ) {
            case 'select':
                $this->select( $field );
                break;
            default:
                $this->input( $field );
        }
    }

    private function input( $field ) {
        printf(
            '<input class="regular-text %s" id="%s" name="%s" %s type="%s" value="%s">',
            isset( $field['class'] ) ? $field['class'] : '',
            $field['id'], $field['id'],
            isset( $field['pattern'] ) ? "pattern='{$field['pattern']}'" : '',
            $field['type'],
            $this->value( $field )
        );
    }

    private function select( $field ) {
        printf(
            '<select id="%s" name="%s">%s</select>',
            $field['id'], $field['id'],
            $this->select_options( $field )
        );
    }

    private function select_selected( $field, $current ) {
        $value = $this->value( $field );
        if ( $value === $current ) {
            return 'selected';
        }
        return '';
    }

    private function select_options( $field ) {
        $output = [];
        $options = explode( "\r\n", $field['options'] );
        $i = 0;
        foreach ( $options as $option ) {
            $pair = explode( ':', $option );
            $pair = array_map( 'trim', $pair );
            $output[] = sprintf(
                '<option %s value="%s"> %s</option>',
                $this->select_selected( $field, $pair[0] ),
                $pair[0], $pair[1]
            );
            $i++;
        }
        return implode( '<br>', $output );
    }

    private function value( $field ) {
        global $post;
        if ( metadata_exists( 'post', $post->ID, $field['id'] ) ) {
            $value = get_post_meta( $post->ID, $field['id'], true );
        } else if ( isset( $field['default'] ) ) {
            $value = $field['default'];
        } else {
            return '';
        }
        return str_replace( '\u0027', "'", $value );
    }

}
new Dtravel_Custom_Field;